/* SPJS Autocomplete for SharePoint v1.6.5
 * ---------------------------------------------
 * Created by Alexander Bautz
 * alexander.bautz@gmail.com
 * http://spjsblog.com
 * Copyright (c) 2014-2017 Alexander Bautz
 * ---------------------------------------------
*/
//# sourceURL=/SPJS/DFFS/plugins/spjs-ac.js
var spjs = spjs || {};

if(typeof jQspjs !== "function" && typeof jQuery === "function"){
    jQspjs = jQuery;
}

spjs.ac = {
	"version":"1.6.5",
	"versionDate":"June 25, 2017",
	"instance":{},
	"data":{
		"styleTagWritten":false,
		"baseUrl":"",
		"usersInGroup":{},
		"isSP07":typeof _spPageContextInfo === "undefined" || _spPageContextInfo.webUIVersion === undefined,
		"isSP13":typeof _spPageContextInfo !== "undefined" && _spPageContextInfo.webUIVersion === 15 ? true : false,
		"isDispForm":location.href.replace("_layouts/15/start.aspx#/","").split("&")[0].match(/dispform.aspx/i) !== null,
		"debug":GetUrlKeyValue("acDebug") === "1",
		"argObj":{},
		"dataObj":{},
		"camlFilterObj":{}
	},
	"getLocalized":function(){
		var lcid = "", sArr = ["noItems","addNewItem","noValidItems","invalid","moreItemsLabel","moreItemsMouseover","searching"];
		if(spjs.ac.text !== undefined){
			jQspjs.each(sArr,function(i,s){
				if(spjs.ac.text[s] === undefined){
					alert("[SPJS Autocomplete]\n\nIt looks like you have a localized text in your autocomplete solution that needs updating. The attribute \"spjs.ac.text."+s+"\" is missing a translation.");
					spjs.ac.text[s] = "[Missing translation, please update]";
				}
			});
			return;
		}
		if(!spjs.ac.data.isSP07){
			lcid = _spPageContextInfo.currentLanguage.toString();
		}else{
			lcid = L_Menu_LCID;
		}		
		switch(lcid){
			case "1044":
				spjs.ac.text = {
					"noItems":"Ingen elementer samsvarer med søket",
					"addNewItem":"Legg til {0} i listen?",
					"noValidItems":"Ingen gyldige elementer funnet",
					"invalid":"Ugyldig verdi",
					"moreItemsLabel":"Viser de {0} første elementene",
					"moreItemsMouseover":"Fortsett å skrive for å begrense søket",
					"searching":"Søker etter: ",
					"multiSelectNoSetFields":"Du kan ikke bruke \"setFields\" i konfigurasjonen når du bruker \"multiselect\" alternativet.",
					"applyToInSetFields":"Feltet \"{0}\" er angitt som \"applyTo\" og kan ikke brukes i \"setFields\" i konfigurasjonen."
				};
			break;
			case "1031":
				spjs.ac.text = {
					"noItems":"Die Suche hat keinen Treffer ergeben",
					"addNewItem":"{0} Einträge zur Liste hinzufügen?",
					"noValidItems":"Die Suche hat keinen gültigen Treffer ergeben",
					"invalid":"Ungültiger Wert",
					"moreItemsLabel":"Anzeige der ersten {0} Eintrage.",
					"moreItemsMouseover":"Fahren Sie mit der Eingabe fort um die Suche einzuengen",
					"searching":"Suche nach: ",
					"multiSelectNoSetFields":"Sie können den Abschnitt \"setFields\" nicht in der Konfiguration verwenden, wenn Sie die Option \"multiselect\" verwenden.",
					"applyToInSetFields":"Das Feld \"{0}\" wird als \"applyTo\" angegeben und kann nicht in dem Abschnitt \"setFields\" in der Konfiguration verwendet werden."
				};
			break;
			default:
				spjs.ac.text = {
					"noItems":"No items match your search",
					"addNewItem":"Add {0} to the list?",
					"noValidItems":"No valid items match your search",
					"invalid":"Invalid value",
					"moreItemsLabel":"Showing the first {0} items",
					"moreItemsMouseover":"Continue typing to narrow your search",
					"searching":"Searching for: ",
					"multiSelectNoSetFields":"You cannot use the \"setFields\" section in the configuration when you are using the \"multiselect\" option.",
					"applyToInSetFields":"The field \"{0}\" is specified as \"applyTo\" and cannot be used in the \"setFields\" section in the configuration."
				};
			break;
		}
	},	
	"applyCSS":function(){
		var b = [];
		b.push("<style type=\"text/css\">");
		b.push(".spjs_acWrap{background-color:#FFFFFF;border:1px silver solid;display:none;position:absolute;min-width:300px;cursor:default;white-space:nowrap;z-index:999;}");
		b.push(".spjs_acItem{border-left:2px transparent solid;border-right:2px transparent solid;padding:4px;cursor:default;white-space:nowrap;border-bottom:1px #efefef solid;}");
		b.push(".spjs_acSelected{background-color:#eff6fc;border-left:2px #0072C6 solid;}");
		b.push(".spjs_acNotFound{padding:4px;cursor:default;white-space:nowrap;color:#818181;}");
		b.push(".spjs_acError{border-color:#E3170D!important;}");
		b.push(".spjs_acItemMoreItems{border-top:1px silver solid;padding:4px;color:#818181;}");
		b.push(".spjs_acAddToList{border-top:1px silver solid;padding:4px;color:#818181;}");
		b.push(".spjs_acDownArr{color:#ababab;position:absolute;margin:1px 0px 0px -20px}");
		b.push(".spjs_ac_multi_clicked{background-color:#0072C6;color:#ffffff;}");
		b.push(".spjs_ac_multi_clicked.spjs_acSelected{border-left:2px #ffffff solid;}");
		b.push(".spjs_ac_multi_selectedWrap{float:left;margin:2px 4px 2px 0px;cursor:default;background-color:#0072C6;color:#ffffff;}");
		b.push(".spjs_ac_multi_selected{float:left;vertical-align:middle;padding:3px;}");
		b.push(".spjs_ac_multi_removeSelected{float:left;cursor:default;padding:3px;color:#0072C6;color:#ffffff;}");
		b.push(".spjs_unselectable{-webkit-touch-callout: none;-webkit-user-select: none;-khtml-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;}");
		b.push(".spjs_ac_multi_removeSelected:hover{background-color:#D41816;color:#ffffff;}");
		b.push(".spjs_dot_red{vertical-align:middle;margin-left:5px;height:12px;width:12px;display:inline-block;background-image:url('data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAwAAAAMCAIAAADZF8uwAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAZdEVYdFNvZnR3YXJlAHBhaW50Lm5ldCA0LjAuMTM0A1t6AAAAFElEQVQoU2N4LM5LEI0qGoSKxHkBy7yT8bIrBA8AAAAASUVORK5CYII=')}");
		b.push(".spjs_ac_searchbox{height:25px;}");
		b.push("<\/style>");
		jQspjs(document).ready(function(){
			jQspjs("body").append(b.join(""));
		});
		spjs.ac.data.styleTagWritten = true;
	},
	"textField":function(argObj){
		if(argObj.debug){
			spjs.ac.data.debug = true;
			if(window.console){
				console.log("[SPJS Autocomplete - Debug output]");
			}
		}
		if(spjs.ac.data.isDispForm){
			// You cannot use the Autocomplete solution in DispForm
			return;
		}
		// Backwards compatibility
		if(argObj.RESTFilter !== undefined){
			argObj.filterREST = argObj.RESTFilter;
		}
		if(argObj.searchFields === undefined){
			argObj.searchFields = [argObj.showField];
		}
		if(jQspjs("#spjs_acWrap_"+argObj.applyTo).length === 0){
			argObj.fieldType = "textField";
			spjs.ac.add(argObj);
		}
	},
	"peoplePicker":function(argObj){
		if(spjs.ac.data.isDispForm){
			// You cannot use the Autocomplete solution in DispForm
			return;
		}
		if(argObj.debug){
			spjs.ac.data.debug = true;
			if(window.console){
				console.log("[SPJS Autocomplete - Debug output]");
			}
		}
		if(argObj.searchFields === undefined){
			argObj.searchFields = [argObj.showField];
		}
		if(spjs.utility.version < 1.181){
			alert("[Autocomplete for SharePoint]\n\nYou must update spjs-utility.js to v1.181 or above.");
		}
		if(jQspjs("#spjs_acWrap_"+argObj.applyTo).length === 0){
			argObj.fieldType = "peoplePicker";
			argObj.listGuid = "UserInfo";
			if(spjs.ac.data.isSP13 && !argObj.forceOn2013){
				alert("[SPJS Autocomplete]\n\nThis solution should not be used for a people picker field in SP2013 as this field already have built in autocomplete.");
			}else{
				jQspjs(document).ready(function(){
					spjs.ac.add(argObj);
				});
			}
		}
	},
	"hideHelp":function(fin){
		jQspjs("#spjs_acHelp_"+fin).hide().next().focus().trigger("click");
	},
	"add":function(argObj){
		var showSpinner = false, sfNotInUse = false;
		if(spjs.ac.data.isSP13){
			if(jQspjs("td.ms-formbody span[id*='"+_spPageContextInfo.pageListId.replace(/\{|\}/g,"")+"']").length>0){
				setTimeout(function(){
					spjs.ac.add(argObj);
				},10);
				return;
			}
			if(argObj.fieldType === "textField" && argObj.useREST === true){
				if(argObj.searchFields.length > 1){
					spjs.ac.data.loadStart = new Date().valueOf();
					showSpinner = true;
					spjs.ac.getAllItemsREST(argObj,null);
				}
			}
		}
		if(fields[argObj.applyTo] === undefined){
			alert("[SPJS Autocomplete for SharePoint]\n\nThe field \""+argObj.applyTo+"\" could not be found.");
			return;
		}		
		if(!spjs.ac.data.isSP07){
			spjs.ac.data.baseUrl = _spPageContextInfo.webServerRelativeUrl !== "/" ? _spPageContextInfo.webServerRelativeUrl : "";
		}else{
			spjs.ac.data.baseUrl = L_Menu_BaseUrl;
		}
		var hb, w = jQspjs(fields[argObj.applyTo]).find("input:text:not('.spjs_ac_hiddenfocusfield'),textarea").first().width();
		if(!spjs.ac.data.styleTagWritten){
			spjs.ac.applyCSS();
		}
		spjs.ac.data.argObj[argObj.applyTo] = argObj;
		spjs.ac.instance[argObj.applyTo] = {
			"applyTo":argObj.applyTo,
			"clicked":false,
			"trigger":false,
			"loadVal":getFieldValue(argObj.applyTo).toString(),
			"setFields":argObj.setFields !== undefined ? argObj.setFields : [],
			"timeout":0,
			"text":{},
			"selectedIndex":null,
			"selectedValue":"",
			"currentValue":"",
			"foundExactMatch":0,
			"multi":argObj.multiselect === true ? true : false,
			"multiselectSeparator":argObj.multiselectSeparator !== undefined ? argObj.multiselectSeparator : ", ",
			"selectedValueMulti":[],
			"selectedIndexMulti":[]
		};
		if(spjs.ac.instance[argObj.applyTo].loadVal.split(";#").length > 1){
			spjs.ac.instance[argObj.applyTo].loadVal = spjs.ac.instance[argObj.applyTo].loadVal.split(";#")[1];
		}
		spjs.ac.getLocalized();
		spjs.ac.instance[argObj.applyTo].text = spjs.ac.text;
		if(argObj.multiselect && argObj.setFields.length > 0){
			argObj.setFields = [];
			sfNotInUse = true;
		}
		jQspjs.each(argObj.setFields,function(i,o){
			if(argObj.applyTo === o.toFIN){
				alert("[SPJS Autocomplete for SharePoint on the field \""+argObj.applyTo+"\"]\n\n"+spjs.ac.instance[argObj.applyTo].text.applyToInSetFields.split("{0}").join(argObj.applyTo));
				argObj.setFields.splice(i,1);
				return false;
			}
		});
		if(argObj.listGuid===undefined){
			alert("[spjs.ac]\nThe configuration for field \""+argObj.applyTo+"\" has an invalid list GUID configured.");
			return;
		}
		jQspjs(fields[argObj.applyTo]).attr("spjs_ac","1");
		hb = [];
		hb.push("<div id='spjs_acWrap_"+argObj.applyTo+"' style='white-space:nowrap;'>");
		hb.push("<span id='spjs_acHelp_"+argObj.applyTo+"' onclick='spjs.ac.hideHelp(\""+argObj.applyTo+"\");' style='position:absolute;padding:3px 0px 0px 4px;color:#818181;display:none;'>"+argObj.helpText+"</span>");
		hb.push("<input id='spjs_ac_"+argObj.applyTo+"' type='search' class='ms-long spjs_ac_searchbox' style='border-width:1px;border-style:solid;min-height:13px;margin:0px;' value='"+spjs.ac.instance[argObj.applyTo].loadVal+"' autocomplete='off'>");
		hb.push("<span style='cursor:default;width:20px;display:inline-block;text-align:center;'>");
		hb.push("<img id='prosessingImg_"+argObj.applyTo+"' class='spjs_ac_icon_"+argObj.applyTo+"' src='");
		if(!spjs.ac.data.isSP07){
			hb.push("/_layouts/"+(spjs.ac.data.isSP13 ? "15/" : "")+"images/loadingcirclests16.gif");
		}else{
			hb.push("/_layouts/images/IMNIDLE.PNG");
		}
		hb.push("' style='height:16px;border:0px;vertical-align:middle;display:none' />");		
		hb.push("<span id='statusImgRed_"+argObj.applyTo+"' class='spjs_ac_icon_"+argObj.applyTo+" spjs_dot_red' style='display:none;'>&nbsp;</span>");
		hb.push("</span>");
		hb.push("<div id='spjs_acWrapFormValidation_"+argObj.applyTo+"'></div>");
		hb.push("</div>");
		hb.push("<div class='spjs_acWrap' style='min-width:"+w+"px;' id='spjs_acPlaceholder_"+argObj.applyTo+"'></div>");
		hb.push("<input class='spjs_ac_hiddenfocusfield' id='spjs_ac_"+argObj.applyTo+"_hiddenFocusField' type='text' style='border:1px red dashed;position:absolute;left:-10000px;'>");
		if(argObj.multiselect){
			if(fields[argObj.applyTo].FieldType === "SPFieldText"){
				hb.push("<div style='color:red;'>This field is multiselect. Please go to list settings and change the field to Multiple lines of text: Plain text.</div>");
			}
			if(fields[argObj.applyTo].FieldType === "SPFieldNote_EHTML"){
				hb.push("<div style='color:red;'>Please go to list settings and change the field to Multiple lines of text: Plain text.</div>");
			}
			if(sfNotInUse){
				hb.push("<div style='color:red;'>"+spjs.ac.instance[argObj.applyTo].text.multiSelectNoSetFields+"</div>");
			}
			hb.push("<div id='spjs_acMultiselect_"+argObj.applyTo+"' style='overflow:auto'></div>");
		}
		hb.push("<span class='spjs_acError' id='spjs_acErrPlaceholder_"+argObj.applyTo+"'></span>");
		if(spjs.ac.data.debug){
			jQspjs(fields[argObj.applyTo]).find("td.ms-formbody span:first").after(hb.join(""));
			jQspjs(fields[argObj.applyTo]).find("textarea:first, input:first").not(".spjs_ac_searchbox").prop("disabled",true).before("<div style='color:red;'>[SPJS Autocomplete DEBUG activated]<br>Hit F12 and select \"Console\" to see the output when you type into the autocomplete. The field below holds the value that will be saved when you save the form.</div>");
		}else{
			jQspjs(fields[argObj.applyTo]).find("td.ms-formbody span:first").hide().after(hb.join(""));
		}
		if(showSpinner){
			jQspjs("#spjs_acWrap_"+argObj.applyTo).hide().before("<div id='spjs_acspinner_"+argObj.applyTo+"'><img src='"+_spPageContextInfo.webServerRelativeUrl+"/_layouts/15/images/gears_anv4.gif' style='height:16px;vertical-align:middle;margin-right:5px;' />"+(argObj.loadText !== undefined ? spjs.ac.localizeString(argObj.loadText) : "")+"</div>");
		}
		if(jQspjs(fields[argObj.applyTo]).find("span.ms-formvalidation").length > 0){
			jQspjs(fields[argObj.applyTo]).find("td.ms-formbody span.ms-formvalidation, td.ms-formbody span.ms-error").appendTo(jQspjs("#spjs_acWrapFormValidation_"+argObj.applyTo));
		}
		if(argObj.listOptionsOnFocus !== undefined && argObj.listOptionsOnFocus){
			jQspjs("#spjs_ac_"+argObj.applyTo).after("<span class='spjs_acDownArr' onclick='jQspjs(this).prev().click();'>\u25BC</span>");
		}		
		jQspjs(fields[argObj.applyTo]).find("input:not('.spjs_ac_hiddenfocusfield'):last").on("focus",function(){
			jQspjs("#spjs_acHelp_"+argObj.applyTo).hide();
			spjs.ac.instance[argObj.applyTo].pVal = jQspjs(this).val();
		}).on("click",function(e){
			if(argObj.listOptionsOnFocus || jQspjs(this).hasClass("spjs_acError")){
				clearTimeout(spjs.ac.instance[argObj.applyTo].timeout);
				spjs.ac.instance[argObj.applyTo].timeout = setTimeout(function(){
					spjs.ac.handle(argObj,false);
				},500);
			}
		}).on("keyup",function(e){
			if(e.keyCode === 13 || e.keyCode === 38 || e.keyCode === 40){
				return;
			}
			if(argObj.minLengthBeforeSearch === undefined){
				argObj.minLengthBeforeSearch = 3;
			}
			if(jQspjs("#spjs_ac_"+argObj.applyTo).val().length < argObj.minLengthBeforeSearch){
				return;
			}
			clearTimeout(spjs.ac.instance[argObj.applyTo].timeout);
			spjs.ac.instance[argObj.applyTo].timeout = setTimeout(function(){
				spjs.ac.handle(argObj,false);
			},500);
		}).on("blur",function(){
			if(jQspjs(this).val() === ""){
				jQspjs("#spjs_acHelp_"+argObj.applyTo).show();
			}
			if(spjs.ac.instance[argObj.applyTo].multi){
				jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).on("mouseleave",function(){
					jQspjs(this).hide().html("");
				});
			}else{
				clearTimeout(spjs.ac.instance[argObj.applyTo].timeout);
				spjs.ac.instance[argObj.applyTo].timeout = setTimeout(function(){
					var cVal = jQspjs("#spjs_ac_"+argObj.applyTo).val();
					if(!spjs.ac.instance[argObj.applyTo].clicked || cVal === "" || jQspjs.inArray(cVal,spjs.ac.instance[argObj.applyTo].choicesArr) < 0){
						if(jQspjs("#spjs_ac_"+argObj.applyTo).val() === ""){
							spjs.ac.instance[argObj.applyTo].selectedIndex = null;
						}
						spjs.ac.verify(argObj.applyTo);
						jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).hide().html("");
					}
				},250);
			}
		}).on("keydown",function(e){
			var sItem;
			jQspjs("#spjs_acHelp_"+argObj.applyTo).hide();
			if(e.keyCode === 38 || e.keyCode === 40){
				clearTimeout(spjs.ac.instance[argObj.applyTo].timeout);
				if(jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acSelected").length===0){
					if(e.keyCode === 40){
						sItem = jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acItem:first").addClass("spjs_acSelected");
					}else if(e.keyCode === 38){
						sItem = jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acItem:last").addClass("spjs_acSelected");
					}
				}else{
					sItem = jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acSelected");
					if(e.keyCode === 40){ // Down
						sItem.removeClass("spjs_acSelected");
						if(sItem.next().length>0){
							sItem.nextAll().each(function(i,e){
								if(jQspjs(e).hasClass("spjs_acItem")){
									sItem = jQspjs(e);
									return false;
								}else if(jQspjs(e).hasClass("spjs_acItemMoreItems")){
									sItem = jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acItem:first").addClass("spjs_acSelected");
								}							
							});
							sItem.addClass("spjs_acSelected");
						}else{
							sItem = jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acItem:first").addClass("spjs_acSelected");
						}
					}else if(e.keyCode === 38){ // Up
						sItem.removeClass("spjs_acSelected");
						if(sItem.prev().length>0){
							sItem.prevAll().each(function(i,e){
								if(jQspjs(e).hasClass("spjs_acItem")){
									sItem = jQspjs(e);
									return false;
								}else{
									sItem = jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acItem:last");
								}						
							});
							sItem.addClass("spjs_acSelected");
						}else{
							sItem = jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acItem:last").addClass("spjs_acSelected");
						}						
					}
				}
			}else if(e.keyCode === 13){
				sItem = jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acSelected");
				jQspjs("#spjs_ac_"+argObj.applyTo+"_hiddenFocusField").focus();
				if(sItem.length>0){
					spjs.ac.instance[argObj.applyTo].selectedIndex = sItem.attr("aindex");
					spjs.ac.instance[argObj.applyTo].selectedValue = sItem.find("div:first").text();
					jQspjs("#spjs_ac_"+argObj.applyTo).val(spjs.ac.instance[argObj.applyTo].selectedValue);
					jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).hide().html("");
					spjs.ac.instance[argObj.applyTo].clicked = true;
					spjs.ac.verify(argObj.applyTo);
				}else{
					spjs.ac.instance[argObj.applyTo].selectedIndex = 0;
					spjs.ac.instance[argObj.applyTo].selectedValue = "";
				}
				return false;
			}else if(e.keyCode === 32 && spjs.ac.instance[argObj.applyTo].multi){
				sItem = jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acSelected");
				if(sItem.length>0){
					spjs.ac.select(argObj.applyTo,sItem[0],false);
					return false;
				}
			}else if(e.keyCode === 9){
				jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).hide().html("");
			}
		});
		if(jQspjs("#spjs_ac_"+argObj.applyTo).val() !== ""){
			if(argObj.reValidateOnLoad && !argObj.multiselect){
				// Not when using getAllItemsREST
				if(!showSpinner){
					spjs.ac.instance[argObj.applyTo].trigger = true;
					clearTimeout(spjs.ac.instance[argObj.applyTo].timeout);
					spjs.ac.instance[argObj.applyTo].timeout = setTimeout(function(){
						spjs.ac.handle(argObj,false);
					},500);
				}
			}
			if(argObj.multiselect){
				spjs.ac.preloadMulti(argObj.applyTo);
			}
		}else{
			jQspjs("#spjs_acHelp_"+argObj.applyTo).show();
		}
	},
	"delete":function(fin){
    	spjs.ac.destroy(fin); 
    },
	"destroy":function(fin){
		if(jQspjs("#spjs_acWrap_"+fin).length > 0){
			jQspjs("#spjs_acWrap_"+fin).remove();
			jQspjs("#spjs_acPlaceholder_"+fin).remove();
			jQspjs("#spjs_acErrPlaceholder_"+fin).remove();
			jQspjs(fields[fin]).attr("spjs_ac","0");
			jQspjs(fields[fin]).find("td.ms-formbody span:first").show();
			clearTimeout(spjs.ac.instance[fin].timeout);
			delete spjs.ac.instance[fin];
		}
	},
	"GetUserCollectionFromGroup":function(gName){
		var result = {"items":[]}, pArr = [["ID","ID"], ["Name","Title"], ["LoginName","Name"], ["Email","EMail"], ["IsSiteAdmin","IsSiteAdmin"],["IsDomainGroup","IsDomainGroup"]], d;
		spjs_wrapSoapRequest(spjs.ac.data.baseUrl + '/_vti_bin/usergroup.asmx', 
		'http://schemas.microsoft.com/sharepoint/soap/directory/GetUserCollectionFromGroup',
		'<GetUserCollectionFromGroup xmlns="http://schemas.microsoft.com/sharepoint/soap/directory/"><groupName>' + gName + '</groupName></GetUserCollectionFromGroup>',
		function(data){
			jQspjs('User', data).each(function(idx, data){
				d = {};
				jQspjs.each(pArr,function(i,a){
					d[a[1]] = jQspjs(data).attr(a[0]);
				});
				result.items.push(d);
			});
		});
		result.count = result.items.length;
		return result;
	},
	"searchUserCollectionFromGroup":function(str,gName){
		if(spjs.ac.data.usersInGroup[gName] === undefined){
			spjs.ac.data.usersInGroup[gName] = spjs.ac.GetUserCollectionFromGroup(gName);
		}
		var fRes = {"items":[]}, m, pArr = ["ID", "Title", "Name", "EMail", "IsSiteAdmin", "IsDomainGroup"];
		jQspjs.each(spjs.ac.data.usersInGroup[gName].items,function(i,o){
			m = false;
			jQspjs.each(o,function(j,p){
				if(jQspjs.inArray(j,pArr) > -1){
					if(p.toLowerCase().indexOf(str.toLowerCase()) > -1){
						m = true;
					}
				}
			});
			if(m){
				fRes.items.push(o);
			}
		});
		fRes.count = fRes.items.length;
		return fRes;
	},
	"getOrderBy":function(a){
		var b = [];
		if(a.orderBy !== undefined){
			if(!jQspjs.isArray(a.orderBy)){
				a.orderBy = [a.orderBy];
			}
			b.push("<OrderBy>");
			jQspjs.each(a.orderBy,function(i,f){
				if(typeof f === "object"){
					b.push("<FieldRef Name='"+f.fin+"' Ascending='"+(f.ascending !== undefined ? String(f.ascending).toUpperCase() : "TRUE")+"' />");
				}else{
					b.push("<FieldRef Name='"+f+"' />");
				}				
			});
			b.push("</OrderBy>");
		}else{
			b.push("<OrderBy><FieldRef Name='"+a.showField+"' /></OrderBy>");
		}
		return b.join("");
	},
	"getMaxIdREST":function(argObj,callback){
		var endpoint, isGuid = spjs.ac.isGuid(argObj.listGuid);
		endpoint = (argObj.listBaseUrl !== undefined ? argObj.listBaseUrl : _spPageContextInfo.webServerRelativeUrl)+ "/_api/web/lists/"+(isGuid ? "getById" : "getbytitle")+"('" + argObj.listGuid + "')/items?$top=1&$orderby=Id desc&$select=Id";
		jQspjs.ajax({
			"url": endpoint,
			"method": "GET",
			"headers": { "Accept": "application/json; odata=verbose" },
			"success": function (data) {
				argObj.maxID = data.d.results[0].Id;
				if(typeof callback !== "undefined"){
					callback();
				}
			},
			"error": function (data) {
				if(window.console){
					console.log("[SPJS Autocomplete - getMaxIdREST - ERROR]");
					console.log(data);
				}
			}
		});
	},
	"getFilteredItemsREST":function (argObj){		
		if(argObj.maxID === undefined){
			argObj.maxID = spjs.ac.getMaxIdREST(argObj,function(){
				spjs.ac.getFilteredItemsREST(argObj);
			});
			return;
		}
		if(argObj.idFrom === undefined){
			argObj.idFrom = 0;
			argObj.idTo = 5000;
		}else{
			argObj.idFrom += 5000;
			argObj.idTo += 5000;
		}
		var endpoint, isGuid = spjs.ac.isGuid(argObj.listGuid), sValArr = argObj.filterVal.split(" "), sFilter = [], filter = "";
		jQspjs.each(argObj.searchFields,function(i,fin){
			sFilter.push("substringof('"+sValArr[0]+"',"+fin+")");
		});
		if(argObj.filterREST !== undefined && argObj.filterREST !== ""){
			filter = " and "+argObj.filterREST;
		}
		filter = spjs.ac.getFilterVariables(argObj,filter);
		endpoint = (argObj.listBaseUrl !== undefined ? argObj.listBaseUrl : _spPageContextInfo.webServerRelativeUrl)+ "/_api/web/lists/"+(isGuid ? "getById" : "getbytitle")+"('" + argObj.listGuid + "')/items?$filter=(Id gt "+argObj.idFrom+" and Id lt "+argObj.idTo+") and "+sFilter.join(" or ")+filter ;
		jQspjs.ajax({
			"url": endpoint,
			"method": "GET",
			"headers": { "Accept": "application/json; odata=verbose" },
			"success": function (data) {
				if(argObj.idFrom === 0){
					spjs.ac.data.dataObj[argObj.applyTo] = {"items":data.d.results,"count":data.d.results.length};
				}else{
					jQspjs.merge(spjs.ac.data.dataObj[argObj.applyTo].items,data.d.results);
					spjs.ac.data.dataObj[argObj.applyTo].count += data.d.results.length;
				}
				if(argObj.idTo < argObj.maxID){
					spjs.ac.getFilteredItemsREST(argObj);
				}else{
					spjs.ac.data.dataObj[argObj.applyTo].done = true;
					spjs.ac.data.loadFinished = new Date().valueOf();
					spjs.ac.filterData(argObj);
				}
			},
			"error": function (data) {
				if(window.console){
					console.log("[SPJS Autocomplete - getFilteredItemsREST - ERROR]");
					console.log(data);
				}
			}
		});
	},
	"getAllItemsREST":function (argObj,endpoint){
		if(endpoint === null){
			var viewFields = argObj.searchFields, expand = [], isGuid = spjs.ac.isGuid(argObj.listGuid), filter = "";
			if(jQspjs.inArray(argObj.showField,viewFields) < 0){
				viewFields.push(argObj.showField);
			}
			jQspjs.each(argObj.optionDetailFields,function(i,fin){
				if(jQspjs.inArray(fin,viewFields) < 0){
					viewFields.push(fin);
				}
			});
			jQspjs.each(argObj.setFields,function(i,o){
				if(jQspjs.isArray(o.fromFIN)){
					jQspjs.each(o.fromFIN,function(i,f){
						if(f.indexOf("/") > -1){
							expand.push(f.split("/")[0]);
						}
						viewFields.push(f);
					});
				}else{
					if(o.fromFIN.indexOf("/") > -1){
						expand.push(o.fromFIN.split("/")[0]);
					}
					viewFields.push(o.fromFIN);
				}
			});
			viewFields.push("Id");
			if(argObj.filterREST !== undefined && argObj.filterREST !== ""){
				filter = "&$filter="+argObj.filterREST;
			}
			filter = spjs.ac.getFilterVariables(argObj,filter);
			endpoint = (argObj.listBaseUrl !== undefined ? argObj.listBaseUrl : _spPageContextInfo.webServerRelativeUrl)+ "/_api/web/lists/"+(isGuid ? "getById" : "getbytitle")+"('" + argObj.listGuid + "')/items?$top=5000&$select="+String(viewFields)+(expand.length > 0 ? "&$expand="+String(expand) : "")+filter;
		}
		jQspjs.ajax({
			"url": endpoint,
			"method": "GET",
			"headers": { "Accept": "application/json; odata=verbose" },
			"success": function (data) {
				if(spjs.ac.data.dataObj[argObj.applyTo] === undefined){
					spjs.ac.data.dataObj[argObj.applyTo] = {"items":[],"done":false};
				}
				jQspjs.merge(spjs.ac.data.dataObj[argObj.applyTo].items,data.d.results);
				if(data.d.__next !== undefined){
					spjs.ac.getAllItemsREST(argObj,data.d.__next);
				}else{
					spjs.ac.data.dataObj[argObj.applyTo].done = true;
					jQspjs("#spjs_acspinner_"+argObj.applyTo).hide().next().show();
					spjs.ac.data.loadFinished = new Date().valueOf();
					if(argObj.reValidateOnLoad && !argObj.multiselect){
						spjs.ac.instance[argObj.applyTo].trigger = true;
						clearTimeout(spjs.ac.instance[argObj.applyTo].timeout);
						spjs.ac.instance[argObj.applyTo].timeout = setTimeout(function(){
							spjs.ac.handle(argObj,false);
						},500);
					}
				}
			},
			"error": function (data) {
				jQspjs("#spjs_acspinner_"+argObj.applyTo).replaceWith("<div style='color:red;'>[SPJS-Autocomplete]<br>"+data.responseJSON.error.message.value+"</div>");
			}
		});
	},
	"filterData":function(argObj){
		var  sValArr = jQspjs("#spjs_ac_"+argObj.applyTo).val().split(" "), arr = [], keep, found, fVal;
		if(sValArr.length === 1 && sValArr[0] === "" && !argObj.listOptionsOnFocus){
			return;
		}
		jQspjs.each(spjs.ac.data.dataObj[argObj.applyTo].items,function(i,item){
			keep = true;
			jQspjs.each(sValArr,function(vi,v){
				v = jQspjs.trim(v);
				if(v !== ""){
					found = false;
					jQspjs.each(argObj.searchFields,function(fi,fin){
						if(fin.split("/").length > 1){
							fVal = item[fin.split("/")[0]][fin.split("/")[1]];
						}else{
							fVal = item[fin] !== null ? String(item[fin]).split(";#").length > 1 ? String(item[fin]).split(";#")[1] : String(item[fin]) : "";
						}
						if(fVal.toLowerCase().match(v.toLowerCase()) !== null){
							found = true;
							// Exit loop
							return false;
						}
					});
					if(!found){
						keep = false;
						// Exit loop
						return false;
					}
				}
			});
			if(keep){
				arr.push(item);
			}
		});
		spjs.ac.buildOptionsMenu(argObj,{"items":arr,"count":arr.length});
	},
	"handle":function(argObj,silent){
		if(silent){
			argObj.silent = true;
		}else{
			argObj.silent = false;
		}
		spjs.ac.instance[argObj.applyTo].addNew = false;
		var val, viewFields, query, res, fCaml = null;
		val = jQspjs("#spjs_ac_"+argObj.applyTo).val();
		spjs.ac.instance[argObj.applyTo].currentValue = val;
		spjs.ac.instance[argObj.applyTo].clicked = false;
		if(val !== "" || (val === "" && argObj.listOptionsOnFocus)){
			if(!spjs.ac.instance[argObj.applyTo].trigger && val !== "" && jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).css("display") === "none"){
				jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).html("<div style='padding:4px;color:#818181;'>"+spjs.ac.instance[argObj.applyTo].text.searching+val+"</div>").show();
			}
			jQspjs(".spjs_ac_icon_"+argObj.applyTo).hide();
			jQspjs("#prosessingImg_"+argObj.applyTo).show();
			argObj.filterVal = val;
			if(spjs.ac.data.isSP13 && argObj.fieldType === "textField" && argObj.useREST === true){
				if(argObj.searchFields.length === 1){
					delete argObj.idFrom;
					delete argObj.idTo;
					spjs.ac.data.loadStart = new Date().valueOf();
					spjs.ac.getFilteredItemsREST(argObj);
				}else{
					spjs.ac.filterData(argObj);
				}
			}else{
				setTimeout(function(){
					if(argObj.fieldType === "peoplePicker"){
						if(argObj.chooseFromUserGroup !== null && argObj.chooseFromUserGroup !== ""){
							if(typeof argObj.chooseFromUserGroup === "number"){
								argObj.chooseFromUserGroup = getUserInfo_v2(argObj.chooseFromUserGroup).Name;
							}
							res = spjs.ac.searchUserCollectionFromGroup(val,argObj.chooseFromUserGroup);
						}else{
							query = [];
							if(val === ""){
								if(argObj.showUsersOnly){
									query.push("<And><IsNotNull><FieldRef Name='ID' /></IsNotNull><Eq><FieldRef Name='ContentType' /><Value Type='Text'>Person</Value></Eq></And>");
								}else{
									query.push("<IsNotNull><FieldRef Name='ID' /></IsNotNull>");
								}
							}else{
								query.push("<Or>");
								query.push("<Or>");
								query.push("<Contains><FieldRef Name='Title' /><Value Type='Text'>"+val.replace(/&/g,"&amp;")+"</Value></Contains>");
								query.push("<Contains><FieldRef Name='Name' /><Value Type='Text'>"+val.replace(/&/g,"&amp;")+"</Value></Contains>");
								query.push("</Or>");
								query.push("<Contains><FieldRef Name='EMail' /><Value Type='Text'>"+val.replace(/&/g,"&amp;")+"</Value></Contains>");
								query.push("</Or>");
							}
							if(argObj.showUsersOnly){
								query.unshift("<And>");
								query.push("<Eq><FieldRef Name='ContentType' /><Value Type='Text'>Person</Value></Eq>");
								query.push("</And>");
							}
							query.unshift("<Where>");
							query.push("</Where>");
							query.push(spjs.ac.getOrderBy(argObj));
							if(spjs.ac.data.debug && window.console){
								console.log("[SPJS Autocomplete - Query]");
								console.log(query.join("\n"));
							}
							viewFields = ["ID"];
							viewFields.push(argObj.showField);
							if(argObj.optionDetailFields !== undefined){
								jQspjs.each(argObj.optionDetailFields,function(k,ofv){
									viewFields.push(ofv);
								});
							}
							if(argObj.searchFields !== undefined){
								jQspjs.each(argObj.searchFields,function(k,ofv){
									viewFields.push(ofv);
								});
							}
							jQspjs.each(spjs.ac.instance[argObj.applyTo].setFields,function(i,o){
								if(jQspjs.isArray(o.fromFIN)){
									jQspjs.each(o.fromFIN,function(i,f){
										viewFields.push(f);
									});
								}else{
									viewFields.push(o.fromFIN);
								}
							});
							res = spjs.utility.queryItemsThrottled({"listName":argObj.listGuid,"query":query.join(""),"viewFields":viewFields,"rowLimit":argObj.rowLimit});
							spjs.ac.data.dataObj[argObj.applyTo] = {"items":res.items,"count":res.count};
							spjs.ac.buildOptionsMenu(argObj,res);
						}
					}else{
						val = val.split(" ")[0];
						if(spjs.ac.data.camlFilterObj[argObj.applyTo] === val){
							spjs.ac.filterData(argObj);
							return;
						}
						spjs.ac.data.camlFilterObj[argObj.applyTo] = val;
						if(argObj.filterCAML !== undefined && argObj.filterCAML !== ""){
							fCaml = spjs.ac.getFilterVariables(argObj,argObj.filterCAML.replace(/<Where>|<\/Where>/g,""));
						}
						if(val === "" && argObj.listOptionsOnFocus){
							query = [];
							query.push("<IsNotNull><FieldRef Name='"+argObj.showField+"' /></IsNotNull>");
							if(fCaml !== null){
								query.push(fCaml.replace(/<Where>|<\/Where>/g,""));
								query.unshift("<And>");
								query.push("</And>");
							}						
							query.unshift("<Where>");
							query.push("</Where>");
							query.push(spjs.ac.getOrderBy(argObj));
						}else{
							query = [];
							jQspjs.each(argObj.searchFields,function(i,f){								
								query.push("<Contains><FieldRef Name='"+f+"' /><Value Type='Text'>"+val.replace(/&/g,"&amp;")+"</Value></Contains>");
								if(i > 0){
									query.unshift("<Or>");
									query.push("</Or>");
								}
							});
							if(fCaml !== null){
								query.push(fCaml);
								query.unshift("<And>");
								query.push("</And>");
							}						
							query.unshift("<Where>");
							query.push("</Where>");
							query.push(spjs.ac.getOrderBy(argObj));
						}
						if(spjs.ac.data.debug && window.console){
							console.log("[SPJS Autocomplete - Query]");
							console.log(query.join("\n"));
						}
						query = query.join("");
						viewFields = ["ID"];
						viewFields.push(argObj.showField);
						if(argObj.optionDetailFields !== undefined){
							jQspjs.each(argObj.optionDetailFields,function(k,ofv){
								viewFields.push(ofv);
							});
						}
						if(argObj.searchFields !== undefined){
							jQspjs.each(argObj.searchFields,function(k,ofv){
								viewFields.push(ofv);
							});
						}
						jQspjs.each(spjs.ac.instance[argObj.applyTo].setFields,function(i,o){
							if(jQspjs.isArray(o.fromFIN)){
								jQspjs.each(o.fromFIN,function(i,f){
									viewFields.push(f);
								});
							}else{
								viewFields.push(o.fromFIN);
							}
						});
						res = spjs.utility.queryItemsThrottled({"listName":argObj.listGuid,"listBaseUrl":argObj.listBaseUrl,"query":query,"viewFields":viewFields,"rowLimit":argObj.rowLimit});
						spjs.ac.data.dataObj[argObj.applyTo] = {"items":res.items,"count":res.count};
						spjs.ac.buildOptionsMenu(argObj,res);
					}
				},100);
			}
		}	
	},
	"buildOptionsMenu":function(argObj,res){
		jQspjs("#spjs_acErrPlaceholder_"+argObj.applyTo).hide();
		if(spjs.ac.data.debug && window.console){
			console.log("[SPJS Autocomplete - buildOptionsMenu - datasource]");
			console.log(res);
		}
		var b = [];
		if(res.count===-1){
			jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).hide().html("");
			jQspjs("#spjs_acErrPlaceholder_"+argObj.applyTo).html("Ensure the list \""+argObj.listGuid+"\" exists on \""+argObj.listBaseUrl+"\", and that the field \""+argObj.showField+"\" does exist in that list.").show();
			jQspjs(fields[argObj.applyTo]).find("input:text:not('.spjs_ac_hiddenfocusfield'),textarea").first().val("");
		}else if(res.count===0){
			jQspjs(fields[argObj.applyTo]).find("input:text:not('.spjs_ac_hiddenfocusfield'),textarea").first().val("");
			if(argObj.filterVal !== ""){
				b.push("<div class='spjs_acNotFound'>"+spjs.ac.instance[argObj.applyTo].text.noItems);
				if(argObj.allowAddNew){
					b.push(" - <span style='color:red;cursor:pointer;' onclick='spjs.ac.addNewItem(\""+argObj.applyTo+"\")'>"+spjs.ac.instance[argObj.applyTo].text.addNewItem.replace("{0}","<i>"+argObj.filterVal+"</i>")+"</span>");
				}
				b.push("</div>");
				jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).html(b.join("")).show();
				jQspjs("#spjs_ac_"+argObj.applyTo).addClass("spjs_acError").attr("title",spjs.ac.instance[argObj.applyTo].text.invalid);
				jQspjs(".spjs_ac_icon_"+argObj.applyTo).hide();
				jQspjs("#statusImgRed_"+argObj.applyTo).show();
			}else{
				jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).hide().html("");
			}
			spjs.ac.instance[argObj.applyTo].selectedIndex = 0;
		}else{
			spjs.ac.instance[argObj.applyTo].sFields = {};
			spjs.ac.instance[argObj.applyTo].foundExactMatch = 0;
			spjs.ac.getChoices(res.items,argObj,argObj.filterVal,argObj.fieldType);
			if(res.count > 0 && spjs.ac.instance[argObj.applyTo].choices.length === 0){
				jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).html("<div class='spjs_acNotFound'>"+spjs.ac.instance[argObj.applyTo].text.noValidItems+"</div>");
				jQspjs("#spjs_ac_"+argObj.applyTo).focus();
				jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).show();
			}else{
				if(spjs.ac.instance[argObj.applyTo].trigger){
					if(spjs.ac.instance[argObj.applyTo].foundExactMatch > 0){
						spjs.ac.instance[argObj.applyTo].selectedIndex = spjs.ac.instance[argObj.applyTo].foundExactMatch;
						spjs.ac.instance[argObj.applyTo].selectedValue = jQspjs("#spjs_ac_"+argObj.applyTo).val();
						spjs.ac.instance[argObj.applyTo].currentValue = spjs.ac.instance[argObj.applyTo].selectedValue;
					}
					spjs.ac.instance[argObj.applyTo].trigger = false;
					spjs.ac.verify(argObj.applyTo);
				}else{
					if(spjs.ac.instance[argObj.applyTo].foundExactMatch > 0){
						spjs.ac.instance[argObj.applyTo].selectedIndex = spjs.ac.instance[argObj.applyTo].foundExactMatch;
						spjs.ac.instance[argObj.applyTo].selectedValue = jQspjs("#spjs_ac_"+argObj.applyTo).val();
						spjs.ac.instance[argObj.applyTo].currentValue = spjs.ac.instance[argObj.applyTo].selectedValue;
					}else{
						if(spjs.ac.instance[argObj.applyTo].multi){
							jQspjs(fields[argObj.applyTo]).find("input:text:not('.spjs_ac_hiddenfocusfield'),textarea").first().val(spjs.ac.instance[argObj.applyTo].selectedValueMulti.join(spjs.ac.instance[argObj.applyTo].multiselectSeparator));
						}else{
							jQspjs(fields[argObj.applyTo]).find("input:text:not('.spjs_ac_hiddenfocusfield'),textarea").first().val("");
						}
						
						spjs.ac.instance[argObj.applyTo].selectedIndex = 0;
					}
					if(!argObj.silent){
						if(spjs.ac.instance[argObj.applyTo].choices.length === argObj.rowLimit){
							spjs.ac.instance[argObj.applyTo].choices.push("<div class='spjs_acItemMoreItems' title='"+spjs.ac.instance[argObj.applyTo].text.moreItemsMouseover+"'>"+spjs.ac.instance[argObj.applyTo].text.moreItemsLabel.replace("{0}",argObj.rowLimit));
							if(argObj.allowAddNew && argObj.filterVal !== "" && jQspjs.inArray(argObj.filterVal,spjs.ac.instance[argObj.applyTo].choicesArr)<0){
								spjs.ac.instance[argObj.applyTo].choices.push(" - <span style='color:red;cursor:pointer;' onclick='spjs.ac.addNewItem(\""+argObj.applyTo+"\")'>"+spjs.ac.instance[argObj.applyTo].text.addNewItem.replace("{0}","<i>"+argObj.filterVal+"</i>")+"</span>");
							}
							spjs.ac.instance[argObj.applyTo].choices.push("</div>");
						}else{
							if(argObj.allowAddNew && argObj.filterVal !== ""){
								if(jQspjs.inArray(argObj.filterVal,spjs.ac.instance[argObj.applyTo].choicesArr)<0){
									spjs.ac.instance[argObj.applyTo].choices.push("<div class='spjs_acAddToList'><span style='color:red;cursor:pointer;' onclick='spjs.ac.addNewItem(\""+argObj.applyTo+"\")'>"+spjs.ac.instance[argObj.applyTo].text.addNewItem.replace("{0}","<i>"+argObj.filterVal+"</i>")+"</span></div>");
								}
							}
						}
						jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).html(spjs.ac.instance[argObj.applyTo].choices.join(""));
						jQspjs("#spjs_ac_"+argObj.applyTo).focus();
						jQspjs("#spjs_acPlaceholder_"+argObj.applyTo).show();
					}
				}
			}
		}
		setTimeout(function(){
			jQspjs("#prosessingImg_"+argObj.applyTo).hide();
			if(spjs.ac.instance[argObj.applyTo].foundExactMatch === 0){
				jQspjs("#statusImgRed_"+argObj.applyTo).show();
			}
		},500);
	},
	"isGuid":function(a){
		return a.match(/[a-f0-9]{8}(?:-[a-f0-9]{4}){3}-[a-f0-9]{12}/i) !== null;
	},
	"getFilterVariables":function(argObj,str){
		// Variables
		var arr = str.match(/\{function:[^\}]*\}/g), s, val;
		if(arr !== null){
			jQspjs.each(arr,function(i,v){
				try{
					s = v.split(":")[1].replace(/\}|\\/g,"");
					val = window[s]();
					str = str.split(v).join(val);
				}catch(err){
					jQspjs("#spjs_acspinner_"+argObj.applyTo).replaceWith("<div style='color:red;'>[SPJS-Autocomplete - error in getFilterVariables]<br>"+err+"</div>");
				}
			});
		}
		return str;
	},
	"addNewItem":function(fin){
		var arg = spjs.ac.data.argObj[fin], a = spjs.ac.instance[fin], v = a.currentValue;
		if(arg.isLookupInSelf){
			jQspjs(fields[a.applyTo]).find("input:text:not('.spjs_ac_hiddenfocusfield'),textarea").first().val(v);
			a.selectedValue = v;
			a.addNew = true;
			jQspjs("#spjs_ac_"+fin).removeClass("spjs_acError");
		}else{
			OpenPopUpPage(arg.listBaseUrl+"/_layouts/15/listform.aspx?PageType=8&ListId="+arg.listGuid,function(result){
				if(result === 1){
					jQspjs("#spjs_ac_"+fin).val(v);
					spjs.ac.handle(arg);
				}
			});
			spjs.ac.prefill(arg.showField,v);
			if(a.setChildFields !== undefined){
				a.addNewAdditionalFields = a.setChildFields;
			}
			if(a.addNewAdditionalFields !== undefined && a.addNewAdditionalFields !== null){
				jQspjs.each(a.addNewAdditionalFields,function(i,o){
					spjs.ac.prefill(o.toFIN,getFieldValue(o.fromFIN));
				});
			}
		}
	},
	"prefill":function(fin,val){
		var dlg = SP.UI.ModalDialog.get_childDialog().get_frameElement();
		if(dlg !== undefined){
			if(jQspjs(dlg).contents().find("input[id^='"+fin+"_']").length < 1){
				setTimeout(function(){
					spjs.ac.prefill(fin,val);
				},100);
			}else{
				jQspjs(dlg).contents().find("input[id^='"+fin+"_']").val(val);
			}
		}		
	},
	"getChoices":function(items,argObj,val,type){
		spjs.ac.instance[argObj.applyTo].choices = [];
		spjs.ac.instance[argObj.applyTo].choicesArr = [];
		var bSel, skip, sVal, lVal, mVal, mArr, b, unique = {};
		bSel = null;
		jQspjs.each(items,function(i,item){
			if(i === argObj.rowLimit){
				return false;
			}		
			skip = false;
			mArr = [];
			spjs.ac.instance[argObj.applyTo].sFields[item.ID] = [];
			jQspjs.each(spjs.ac.instance[argObj.applyTo].setFields,function(j,o){
				if(jQspjs.isArray(o.fromFIN)){
					sVal = [];
					jQspjs.each(o.fromFIN,function(i,f){
						if(f.indexOf("/") > -1){
							sVal.push(item[f.split("/")[0]] !== null ? item[f.split("/")[0]][f.split("/")[1]] : "");
						}else{
							if(item[f] !== null){
								sVal.push(item[f]);
							}else{
								sVal.push("");
							}
						}
					});
					if(o.joinBy !== undefined && o.joinBy !== ""){
						sVal = sVal.join(o.joinBy);
					}
				}else{
					sVal = item[o.fromFIN] !== null ? item[o.fromFIN] : "";
					if(item[o.fromFIN] !== null){
						sVal = item[o.fromFIN];
					}else{
						sVal = "";
					}
				}
				if(sVal === "" && o.skipIfEmpty){
					skip = true;
					return false;
				}
				spjs.ac.instance[argObj.applyTo].sFields[item.ID].push({"fin":o.toFIN,"val":sVal,"pf":o.parseFunction !== undefined ? o.parseFunction : ""});
			});
			if(skip){
				return;
			}
			lVal = item[argObj.showField];
			if(unique[lVal] !== undefined && argObj.enforceUniqueValues){
				return;
			}
			unique[lVal] = true;
			if(typeof lVal === "string"){
				lVal = lVal.replace(/'/g,"&apos;").replace(/"/g,"&quot;");
				if(lVal.split(";#").length>1){
					lVal = lVal.split(";#")[1];
				}
			}
			b = [];
			if(type === "peoplePicker" && item.EMail !== null){
				b.push("<div title='"+item.EMail+"' aindex='"+item.ID+"' class='spjs_acItem");
			}else{
				b.push("<div title='"+lVal+"' aindex='"+item.ID+"' class='spjs_acItem");
			}
			if(lVal === val){
				if(bSel === null){
					b.push(" spjs_acSelected");
					bSel = true;
					spjs.ac.instance[argObj.applyTo].foundExactMatch = item.ID;
				}else if(bSel){
					bSel = false;
					spjs.ac.instance[argObj.applyTo].foundExactMatch = 0;
				}					
			}
			if(jQspjs.inArray(lVal,spjs.ac.instance[argObj.applyTo].selectedValueMulti) > -1){
				b.push(" spjs_ac_multi_clicked");
			}
			if(argObj.optionDetailFields !== undefined){
				jQspjs.each(argObj.optionDetailFields,function(k,odv){
					mVal = item[odv] !== null ? item[odv] : "";
					if(typeof mVal === "string"){
						if(mVal.split(";#").length>1){
							mVal = mVal.split(";#")[1];
						}
					}
					if(mVal !== ""){
						if(typeof argObj.optionDetailPrefix === "object" && argObj.optionDetailPrefix[k] !== undefined && argObj.optionDetailPrefix[k] !== ""){
							mVal = spjs.ac.localizeString(argObj.optionDetailPrefix[k]) + mVal;
						}
						mArr.push("<div>"+mVal+"</div>");
					}
				});
			}
			b.push("' onmouseover='spjs.ac.hover(\""+argObj.applyTo+"\",this)' onclick='spjs.ac.select(\""+argObj.applyTo+"\",this,true)' value='"+lVal+"'><div class='spjs_acLabel'>"+lVal+"</div>"+mArr.join("")+"</div>");
			spjs.ac.instance[argObj.applyTo].choices.push(b.join(""));
			spjs.ac.instance[argObj.applyTo].choicesArr.push(lVal);
		});
	},
	"localizeString":function(a){
		var b = a;
		if(typeof b === "object"){
			try{
				if(b[L_Menu_LCID] !== undefined){
					b = b[L_Menu_LCID];
				}else if(b["default"] !== undefined){
					b = b["default"];
				}
			}catch(ignore){
				// Nothing
			}
		}
		return b;
	},
	"hover":function(fin,elm){
		jQspjs(".spjs_acSelected").removeClass("spjs_acSelected");
		jQspjs(elm).addClass("spjs_acSelected");
	},
	"select":function(fin,elm,clearInput){
		var index, sId;
		if(spjs.ac.instance[fin].multi){
			if(jQspjs(elm).hasClass("spjs_ac_multi_clicked")){
				jQspjs(elm).removeClass("spjs_ac_multi_clicked");
				sId = spjs.ac.idFromString(jQspjs(elm).find(".spjs_acLabel").text());
				spjs.ac.removeSelection(document.getElementById(fin+"_"+sId),fin);
				return;
			}
		}
		spjs.ac.instance[fin].clicked = true;
		clearTimeout(spjs.ac.instance[fin].timeout);
		jQspjs("#spjs_ac_"+fin).val(jQspjs(elm).find(".spjs_acLabel").text());
		if(elm === undefined){
			elm = jQspjs("#spjs_acPlaceholder_"+fin).find("div.spjs_acSelected");
		}
		index = jQspjs(elm).attr("aindex");
		spjs.ac.instance[fin].selectedIndex = index;
		spjs.ac.instance[fin].selectedValue = jQspjs("#spjs_ac_"+fin).val();
		spjs.ac.instance[fin].currentValue = spjs.ac.instance[fin].selectedValue;

		if(spjs.ac.instance[fin].multi){
			jQspjs(elm).addClass("spjs_ac_multi_clicked").one("click",function(){
				jQspjs(elm).removeClass("spjs_ac_multi_clicked");
				sId = spjs.ac.idFromString(spjs.ac.instance[fin].selectedValue);
				spjs.ac.removeSelection(document.getElementById(fin+"_"+sId),fin);
			});
		}else{
			jQspjs("#spjs_acPlaceholder_"+fin).hide().html("");
		}
		jQspjs("#spjs_ac_"+fin).removeClass("spjs_acError").attr("title","");
		spjs.ac.verify(fin);
	},
	"verify":function(fin){
		var index, cVal;
		cVal = jQspjs("#spjs_ac_"+fin).val();
		spjs.ac.instance[fin].clicked = false;
		index = spjs.ac.instance[fin].selectedIndex;
		if(index === null){
			if(spjs.ac.instance[fin].choicesArr === undefined){
				spjs.ac.handle(spjs.ac.data.argObj[fin],true);
				return;
			}
			if(jQspjs.inArray(cVal,spjs.ac.instance[fin].choicesArr)<0){
				jQspjs("#dffs_"+fin).find("input:text:not('.spjs_ac_hiddenfocusfield'),textarea").first().val("");
				jQspjs("#spjs_ac_"+fin).addClass("spjs_acError").attr("title",spjs.ac.instance[fin].text.invalid);
				jQspjs(".spjs_ac_icon_"+fin).hide();
				jQspjs("#statusImgRed_"+fin).show();
			}
		}else if(index===0 || spjs.ac.instance[fin].selectedValue !== cVal){
			if(spjs.ac.instance[fin].addNew){
				jQspjs(".spjs_ac_icon_"+fin).hide();
			}else{
				if(!spjs.ac.instance[fin].multi){
					jQspjs("#dffs_"+fin).find("input:text:not('.spjs_ac_hiddenfocusfield'),textarea").first().val("");
					jQspjs("#spjs_ac_"+fin).val(cVal);
					jQspjs.each(spjs.ac.instance[fin].setFields,function(i,o){
						setFieldValue(o.toFIN,"");
					});
					if(cVal !== ""){
						jQspjs("#spjs_ac_"+fin).addClass("spjs_acError").attr("title",spjs.ac.instance[fin].text.invalid);
						jQspjs(".spjs_ac_icon_"+fin).hide();
						jQspjs("#statusImgRed_"+fin).show();
					}else{
						jQspjs("#spjs_ac_"+fin).removeClass("spjs_acError").attr("title","");
						jQspjs(".spjs_ac_icon_"+fin).hide();
					}
				}
			}		
		}else{
			jQspjs("#spjs_acHelp_"+fin).hide();
			jQspjs("#spjs_ac_"+fin).removeClass("spjs_acError").attr("title","");
			jQspjs(".spjs_ac_icon_"+fin).hide();
			if(spjs.ac.instance[fin].multi){
				spjs.ac.multi(fin);
			}else{
				jQspjs("#dffs_"+fin).find("input:text:not('.spjs_ac_hiddenfocusfield'),textarea").first().val(spjs.ac.instance[fin].selectedValue);
				// Trigger change event
				try{
					if(spjs.dffs.ruleObj.triggerMapContext[fin] !== undefined){
						spjs.dffs.triggerOnChange(fin);
					}
				}catch(ignore){
					// Nothing
				}
				if(index!==""){
					jQspjs.each(spjs.ac.instance[fin].sFields[index],function(i,o){
						var val = o.val;
						if(o.pf !== ""){
							try{
								val = window[o.pf](o.val);
							}catch(ignore){
								// Nothing
							}
						}else{
							if(typeof o.val === "string" && o.val.split(";#").length > 1){
								val = o.val.split(";#")[1];
							}
						}
						setFieldValue(o.fin,val);
						// Trigger change event
						try{
							if(spjs.dffs.ruleObj.triggerMapContext[o.fin] !== undefined){
								spjs.dffs.triggerOnChange(o.fin);
							}
						}catch(ignore){
							// Nothing
						}
						switch(jQspjs(fields[o.fin]).attr("FieldType")){
							case "SPFieldChoice":
								jQspjs(fields[o.fin]).find("select").trigger("change");
							break;
							case "SPFieldNote":
								jQspjs(fields[o.fin]).find("textarea").trigger("change");
							break;
							case "SPFieldMultiChoice":
								jQspjs(fields[o.fin]).find("input:checkbox").trigger("change");
							break;
							default:
								jQspjs(fields[o.fin]).find("input:text").trigger("blur");
						}
						if(jQspjs(fields[o.fin]).find("td.ms-formbody").length > 1){
							if(jQspjs(fields[o.fin]).attr("FieldType").match("SPFieldUser") !== null && o.val !== ""){
								jQspjs(fields[o.fin]).find("td.ms-formbody").last().html("...");
								spjs.ac.updateReadonlyPeoplePicker(o.fin,0);
							}else{
								jQspjs(fields[o.fin]).find("td.ms-formbody").last().html(o.val);
							}
						}
					});
				}
			}	
		}
	},
	"preloadMulti":function(fin){
		var a = spjs.ac.instance[fin], cVal = jQspjs("#spjs_ac_"+fin).val();
		jQspjs.each(cVal.split(a.multiselectSeparator),function(i,v){
			a.selectedValueMulti.push(v);
			a.selectedIndexMulti.push("");
		});
		if(a.selectedValueMulti.length > 0){
			spjs.ac.multi(fin);
		}
	},
	"idFromString":function(a){
		var s = [];
		jQspjs.each(a.split(""),function(i,c){
			s.push(c.charCodeAt(0));
		});
		return s.join("-");
	},
	"multi":function(fin){
		var a = spjs.ac.instance[fin], b = [];
		if(a.selectedValue !== "" && jQspjs.inArray(a.selectedValue,a.selectedValueMulti)<0){
			a.selectedValueMulti.push(a.selectedValue);
		}
		a.selectedValue = "";
		a.selectedIndex = null;
		if(a.selectedValueMulti.length > 0){
			jQspjs.each(a.selectedValueMulti,function(i,v){
				b.push("<div class='spjs_ac_multi_selectedWrap'>");
				b.push("<div class='spjs_ac_multi_selected spjs_unselectable'>");
				b.push(v);
				b.push("</div>");
				b.push("<div id='"+fin+"_"+spjs.ac.idFromString(v)+"' class='spjs_ac_multi_removeSelected' onclick='spjs.ac.removeSelection(this,\""+fin+"\");'>");
				b.push("&#10005;");
				b.push("</div>");
				b.push("</div>");
			});
			jQspjs("#spjs_acMultiselect_"+fin).html(b.join(""));
			jQspjs("#dffs_"+fin).find("input:text:not('.spjs_ac_hiddenfocusfield'),textarea").first().val(a.selectedValueMulti.join(a.multiselectSeparator));
			// Trigger change event
			try{
				if(spjs.dffs.ruleObj.triggerMapContext[fin] !== undefined){
					spjs.dffs.triggerOnChange(fin);
				}
			}catch(ignore){
				// Nothing
			}
			jQspjs("#spjs_ac_"+fin).val("");
			jQspjs("#spjs_acHelp_"+fin).show();
		}
	},
	"removeSelection":function(elm,fin,index){
		if(elm === null){
			return;
		}
		var a = spjs.ac.instance[fin], val = jQspjs(elm).parent().find(".spjs_ac_multi_selected").text(), ap = jQspjs.inArray(val,a.selectedValueMulti);
		jQspjs(elm).parents(".spjs_ac_multi_selectedWrap").remove();
		spjs.ac.instance[fin].selectedValueMulti.splice(ap,1);
		spjs.ac.instance[fin].selectedIndexMulti.splice(ap,1);
		jQspjs("#dffs_"+fin).find("input:text:not('.spjs_ac_hiddenfocusfield'),textarea").first().val(a.selectedValueMulti.join(a.multiselectSeparator));
		// Trigger change event
		try{
			if(spjs.dffs.ruleObj.triggerMapContext[fin] !== undefined){
				spjs.dffs.triggerOnChange(fin);
			}
		}catch(ignore){
			// Nothing
		}
		jQspjs("#spjs_ac_"+fin).val("");
	},
	"updateReadonlyPeoplePicker":function(fin,c){
		if(c > 10){
			return;
		}
		var ppVal = getFieldValue(fin);
		if(ppVal !== ""){
			jQspjs(fields[fin]).find("td.ms-formbody").last().html(ppVal);
		}else{
			setTimeout(function(){
				spjs.ac.updateReadonlyPeoplePicker(fin,(c+1));
			},1000);
		}
	}
};