﻿/* Build a dropdown select in a "Single line of text" field populated from a query.
 * ---------------------------------------------
 * Created by Alexander Bautz
 * alexander.bautz@gmail.com
 * http://spjsblog.com
 * Copyright (c) 2015-2017 Alexander Bautz
*/
//# sourceURL=/SPJS/DFFS/plugins/spjs-lookup.js
var spjs = spjs || {};

if(typeof jQspjs !== "function" && typeof jQuery === "function"){
    jQspjs = jQuery;
}

spjs.lookup = {
	"data":{
		"version":"1.1.8",
		"versionDate":"March 23, 2016",
		"fields":null,
		"addNew":{}
	},
	"intFields":function(){
		var a, b = {}, c = false;
		jQspjs("td.ms-formbody").each(function(){
			a = jQspjs(this).html().match(/FieldName="(.+)"\s+FieldInternalName="(.+)"\s+FieldType="(.+)"\s+/);
			if(a !== null){
				if(a[3] === "SPFieldText"){
					c = true;
					b[a[2]] = this.parentNode;
				}
			}		
		});
		if(c){
			spjs.lookup.data.fields = b;
		}
	},
	"init":function(argObj){
		if(typeof _spPageContextInfo !== "undefined"){
			if(jQspjs("td.ms-formbody span[id*='"+_spPageContextInfo.pageListId.replace(/\{|\}/g,"")+"']").length>0){
				setTimeout(function(){
					spjs.lookup.init(argObj);
				},10);
				return;
			}
		}
		if(typeof argObj.fieldToConvertToDropdown !== "object"){
			argObj.fieldToConvertToDropdown = [argObj.fieldToConvertToDropdown];
		}
		jQspjs.each(argObj.fieldToConvertToDropdown,function(i,fin){
			spjs.lookup.data.addNew[argObj.listBaseUrl+argObj.listName+fin] = {"fin":fin,"args":argObj,"opt":""};
			spjs.lookup.intFields();
			if(spjs.lookup.data.fields === null){
				alert("[spjs.lookup]\nNo text fields found in the list. Please note that this code will only work with unmodified list forms.");
				return;
			}
			if(argObj.listName===undefined){
				alert("[spjs.lookup error]\n\nThe value for paramenter \"listName\" is undefined.");
				return;
			}
			var tr, inp, cVal, db, isError, opt, ob, qb, query, qP = {}, viewFields, res, found = false, ds, sVal, sText, doKill = false;
			tr = jQspjs(spjs.lookup.data.fields[fin]);
			inp = tr.find('.ms-formbody input');
			cVal = inp.val();
			db = ["<div style='font-size:14px;'>[SPJS-Lookup for SharePoint v"+spjs.lookup.data.version+"]</div>"];
			isError = false;
			if(spjs.lookup.data.fields[fin]===undefined){
				db.push("<div>The field \"" + fin + "\", assigned as \"fieldToConvertToDropdown\", does not exist.\n\nEnsure the correct \"FieldInternalName\" is used.</div>");
				isError = true;
			}	
			if(!argObj.debug){
				inp.hide();
			}
			opt = {};
			ob = [];
			if(argObj.dropDownDefaultvalue !== "" || (argObj.dropDownDefaultvalue === "" && inp.val() === "")){
				ob.push("<option value=''>"+spjs.lookup.localizeString(argObj.dropDownDefaultvalue)+"</option>");
			}
			if(i === 0){
				qb = [];
				if(argObj.filterObj.on){
					if(argObj.filterObj.CAML !== null){
						qb.push(argObj.filterObj.CAML);
					}else{
						qb.push("<IsNotNull><FieldRef Name='"+argObj.optTextFieldInternalName+"' /></IsNotNull>");
						if(argObj.filterObj.operator !== "IsNotNull"){
							qb.unshift("<And>");
							qb.push("<"+argObj.filterObj.operator+"><FieldRef Name='"+argObj.filterObj.fin+"' "+(argObj.filterObj.isLookup===true?"LookupId='TRUE'":"")+" /><Value Type='"+(argObj.filterObj.isLookup===true?"Lookup":"Text")+"'>"+argObj.filterObj.filterVal+"</Value></"+argObj.filterObj.operator+">");
							qb.push("</And>");
						}
						qb.unshift("<Where>");
						qb.push("</Where>");
					}
				}else{
					qb.push("<Where><IsNotNull><FieldRef Name='"+argObj.optTextFieldInternalName+"' /></IsNotNull></Where>");
				}
				if(argObj.sortFieldName !== "undefined" && argObj.orderBy === undefined){
					argObj.orderBy = argObj.sortFieldName;
				}
				qb.push("<OrderBy><FieldRef Name='"+(typeof argObj.orderBy === "object" ? argObj.orderBy.fin : argObj.orderBy)+"' Ascending='"+(typeof argObj.orderBy === "object" ? argObj.orderBy.ascending : "TRUE")+"'/></OrderBy>");
				query = qb.join("").replace(/&/g,'&amp;');
				viewFields = ['ID',argObj.optTextFieldInternalName];
				if(argObj.optValFieldInternalName !== undefined && argObj.optValFieldInternalName !== ""){
					viewFields.push(argObj.optValFieldInternalName);
				}
				qP.listName = argObj.listName;
				qP.listBaseUrl = argObj.listBaseUrl;
				qP.query = query;
				if(argObj.filterObj.folder !== undefined && argObj.filterObj.folder !== ""){
					qP.folder = argObj.filterObj.folder;
				}
				qP.scope = "Recursive";
				qP.viewFields = viewFields;
				res = spjs_QueryItems(qP);
				if(res.count < 0){
					isError = true;
				}else{
					jQspjs.each(res.items,function(i,item){
						if(opt[item[argObj.optTextFieldInternalName]]===undefined){
							var t = item[argObj.optTextFieldInternalName] !== null ? item[argObj.optTextFieldInternalName] : "", v = item.ID, pt, pf;
							if(argObj.optValFieldInternalName !== undefined && argObj.optValFieldInternalName !== "" && item[argObj.optValFieldInternalName] !== null){
								v = item[argObj.optValFieldInternalName];
							}
							if(t.split(';#').length>1){
								t = t.split(';#')[1];
							}
							if(argObj.parseFunction !== undefined && argObj.parseFunction !== ""){
								try{
									pt = window[argObj.parseFunction](t);
									pf = jQspjs.isArray(argObj.fieldToConvertToDropdown) ? argObj.fieldToConvertToDropdown[0] : argObj.fieldToConvertToDropdown;
									if(pt === undefined || pt === null){	
										if(jQspjs("#spjsLookupParseFuncError_"+pf).length === 0){									
											jQspjs("#dffs_"+pf).find("input").after("<div id='spjsLookupParseFuncError_"+pf+"' style='color:red;'>There is an error in the function \""+argObj.parseFunction+"\. You passed in this value: \""+t+"\", but your custom parse function returned \""+pt+"\".</div>");
										}
									}else{
										t = pt;
									}
								}catch(ignore){
									// Nothing
								}
							}
							opt[item[argObj.optTextFieldInternalName]]="<option value='"+v+"'>"+t+"</option>";
						}	
					});
				}
				if(isError||argObj.debug){			
					db.push("<div><strong>ListName:</strong> "+argObj.listName+"</div>");
					db.push("<div><strong>Query:</strong> "+query.replace(/</g,'&lt;').replace(/>/g,'&gt;')+"</div>");
					db.push("<div><strong>ViewFields:</strong> "+viewFields+"</div>");
					db.push("<div style='padding-top:5px'><strong>Query returned "+res.count+" items.</strong></div>");
				}
				jQspjs.each(opt,function(j,val){
					ob.push(val);
				});
				spjs.lookup.data.addNew[argObj.listBaseUrl+argObj.listName+fin].opt = ob.join("");
			}else{
				ob = spjs.lookup.data.addNew[argObj.listBaseUrl+argObj.listName+argObj.fieldToConvertToDropdown[0]].opt;
			}	
			if(jQspjs("#"+fin+"_spjs_lookup").length === 0){
				ds = jQspjs("<select></select>");
				ds.attr('id',fin+"_spjs_lookup");
				ds.change(function(){
					sVal = jQspjs(this).val();
					sText = jQspjs(this).find('option:selected').text();
					if(sVal!==""){
						inp.val(sText);
					}else{
						inp.val("");
					}
					inp.trigger("blur"); // Trigger rules configured with DFFS
				});
				ds.html(ob);
				inp.before(ds);
			}else{
				jQspjs("#"+fin+"_spjs_lookup").html(ob).show();
			}
			if(cVal===""){
				found = true;
			}
			if(!argObj.clearInvalidSelections && !found){
				jQspjs("#"+fin+"_spjs_lookup").append("<option value='0'>"+cVal+"</option>");
			}
			jQspjs("#"+fin+"_spjs_lookup").find("option").each(function(){
				if(jQspjs(this).text()===cVal){
					jQspjs(this).prop("selected",true);
					found = true;
				}else{
					jQspjs(this).prop("selected",false);
				}
			});
			if(!found){				
				if(argObj.addYouOwnValue.on){
					doKill = true;
					db.push("<div style='padding-top:10px'><strong>Current field value:</strong> \""+cVal+"\", was <strong>NOT</strong> found in the available values returned by the query, but because addYouOwnValue is set to true, the custom value is shown.</div>");
				}else{
					inp.val("");
					db.push("<div style='padding-top:10px'><strong>Current field value:</strong> \""+cVal+"\", was <strong>NOT</strong> found in the available values returned by the query. The field value has been cleared.</div>");
				}
			}else{
				jQspjs("#"+fin+"_spjs_lookup").trigger("change");
			}
			jQspjs("#"+fin+"_spjs_lookup").siblings("a").remove();
			if(argObj.addYouOwnValue.on){
				jQspjs("#"+fin+"_spjs_lookup").after("<a id='"+fin+"_spjs_lookup_kill' style='margin-left:6px;' href='javascript:' onclick='spjs.lookup.kill(\""+fin+"\")'>"+spjs.lookup.localizeString(argObj.addYouOwnValue.linkText)+"</a>");
			}
			if(argObj.addToExternalList!==undefined){
				if(argObj.addToExternalList.on){
					jQspjs("#"+fin+"_spjs_lookup").after("<a id='"+fin+"_spjs_lookup_add' style='margin-left:6px;' href='javascript:' onclick='spjs.lookup.add(\""+argObj.listBaseUrl+argObj.listName+fin+"\");'>"+spjs.lookup.localizeString(argObj.addToExternalList.linkText)+"</a>");
				}
			}
			if(isError||argObj.debug){
				db.push("<pre style='background-color:#ffffff;'>"+JSON.stringify(argObj,null,4)+"</pre>");
				jQspjs("#dffs_"+argObj.fieldToConvertToDropdown[0]).find("td.ms-formbody").append("<div style='background-color:#FCD116;padding:10px;font-size:10px'>"+db.join("")+"</div>");
			}
			if(doKill){
				spjs.lookup.kill(fin);
			}
		});
	},
	"kill":function(fin){
		jQspjs("#"+fin+"_spjs_lookup").hide().siblings("a").hide().siblings("input").css({"width":"370px"}).show().after("<a href='javascript:' onclick='spjs.lookup.regretKill(this,\""+fin+"\")'><img style='vertical-align:middle;border:none;' src='data:image/gif;base64,R0lGODlhEAAQAMQfAGdoanV3eXt9f2NlZl9hYlxeX4SGiXFzdH2Agnh6fE1PUH1/gWttboKEhoOGiG9xc1tcXllZW1laXHd5e2VlaExNTnR1d1BSU1NUVVVWV2lrbGxub4CChGJjZXp7ff///yH5BAEAAB8ALAAAAAAQABAAAAU54CeOZGmeaKquomGQiIA6DSd6k5UuQhJYj5Xl8GCwNhrAYAWgdAgFSepZEGUwFxQkQlJUWOCwOBwCADs='/></a>");
	},
	"regretKill":function(elm,fin){
		jQspjs(elm).remove();
		jQspjs("#"+fin+"_spjs_lookup").show().siblings("a").show().siblings("input").hide();
	},
	"add":function(a){
		var s = spjs.lookup.data.addNew[a];
		jQspjs("#"+s.fin+"_spjs_lookup_add").hide();
		jQspjs("#"+s.fin+"_spjs_lookup_kill").hide();
		if(s.args.addToExternalList.customFunction !== "" && s.args.addToExternalList.customFunction !== null){
			try{
				window[s.args.addToExternalList.customFunction](s);
			}catch(err){
				jQspjs('body').prepend("<div style='background-color:#FCD116;padding:10px;font-size:10px'>Error in addToExternalList.customFunction: "+err+"</div>");
			}
		}else{
			jQspjs("#"+s.fin+"_spjs_lookup").hide().siblings("input").show().after("<span id='"+s.fin+"_spjs_lookup_addNewBtn'><a href='javascript:' style='margin-left:4px;' onclick='spjs.lookup.doAdd(this,\""+a+"\")'>"+spjs.lookup.localizeString(s.args.addToExternalList.saveNewItemText)+"</a><a style='margin-left:4px;' href='javascript:' onclick='spjs.lookup.regretAdd(\""+s.fin+"\")'><img style='vertical-align:middle;border:none;' src='data:image/gif;base64,R0lGODlhEAAQAMQfAGdoanV3eXt9f2NlZl9hYlxeX4SGiXFzdH2Agnh6fE1PUH1/gWttboKEhoOGiG9xc1tcXllZW1laXHd5e2VlaExNTnR1d1BSU1NUVVVWV2lrbGxub4CChGJjZXp7ff///yH5BAEAAB8ALAAAAAAQABAAAAU54CeOZGmeaKquomGQiIA6DSd6k5UuQhJYj5Xl8GCwNhrAYAWgdAgFSepZEGUwFxQkQlJUWOCwOBwCADs='/></a></span>");
		}		
	},
	"regretAdd":function(fin){
		jQspjs("#"+fin+"_spjs_lookup_addNewBtn").remove();
		jQspjs("#"+fin+"_spjs_lookup").show().siblings("a").show().siblings("input").hide();
	},
	"doAdd":function(elm,a){
		var s = spjs.lookup.data.addNew[a], b, c = {}, d = getFieldValue(s.fin), e = jQspjs("#"+s.fin+"_spjs_lookup").siblings("input")[0];
		if(d === ""){
			e.style.backgroundColor = "#FFCCCC";
			return;
		}else{
			e.style.backgroundColor = "";
		}
		jQspjs("#"+s.fin+"_spjs_lookup_addNewBtn").remove();
		c[s.args.optTextFieldInternalName] = d;		
		b = spjs_addItem({"listName":s.args.listName,"listBaseUrl":s.args.listBaseUrl,"data":c});
		if(b.success){
			spjs.lookup.init(s.args);
		}else{
			alert(b.errorText);
		}
	},
	"setValue":function(a,b){
		jQspjs("#"+a+"_spjs_lookup").find("option").each(function(){
			if(jQspjs(this).text() === b){
				jQspjs(this).prop("selected",true).trigger("change");
				return false;
			}
		});
	},
	"localizeString":function(a){
		var b = a;
		if(typeof b === "object"){
			try{
				if(b[L_Menu_LCID] !== undefined){
					b = b[L_Menu_LCID];
				}else if(b["default"] !== undefined){
					b = b["default"];
				}
			}catch(ignore){
				// Nothing
			}
		}
		return b;
	}
};